<template>
  <div
    data-component-group="filter-forms"
    data-component="businesses"
  >
    <FiltersForm
      :has-filters="hasFilters"
      @filter="onFilter"
      @clear="onClearFilters"
    >
      <Can
        I="see-business-search"
        a="filter"
      >
        <v-text-field
          v-model="search"
          type="search"
          label="Search"
          prepend-inner-icon="search"
        />
      </Can>

      <v-autocomplete
        v-model="selectedLabels"
        :items="labels"
        :filter="customFilter"
        :multiple="true"
        label="Labels"
        item-text="name"
        item-value="code"
        :return-object="true"
        required
        prepend-inner-icon="label"
        :menu-props="{nudgeBottom:'10'}"
      />

      <Can
        I="see-business-country"
        a="filter"
      >
        <v-autocomplete
          v-model="country"
          :items="countries"
          :filter="customFilter"
          label="Country"
          item-text="name"
          item-value="code"
          :return-object="true"
          required
          prepend-inner-icon="public"
          :menu-props="{nudgeBottom:'10'}"
        />
      </Can>

      <Can
        I="see-business-status"
        a="filter"
      >
        <v-autocomplete
          v-model="status"
          :items="statuses"
          :filter="customFilter"
          label="Status"
          item-text="name"
          item-value="id"
          :return-object="true"
          required
          prepend-inner-icon="change_history"
          :menu-props="{nudgeBottom:'10'}"
        />
      </Can>

      <v-autocomplete
        v-model="dealSubmission"
        :items="userCountries"
        :filter="customFilter"
        label="Deal submission enabled"
        item-text="name"
        item-value="code"
        :return-object="true"
        required
        prepend-inner-icon="public"
        :menu-props="{nudgeBottom:'10'}"
      />

      <v-autocomplete
        v-model="selectedAccountTypes"
        :items="accountTypes"
        :filter="customFilter"
        :multiple="true"
        label="Account types"
        item-text="name"
        item-value="code"
        :return-object="true"
        required
        prepend-inner-icon="label_important"
        :menu-props="{nudgeBottom:'10'}"
      />
    </FiltersForm>
  </div>
</template>

<script>
  import colors from 'vuetify/es5/util/colors';
  import stringEscape from 'js-string-escape';
  import FiltersForm from './Filters';
  import { isStr, isNum } from '../../../utils';

  // TODO: Translate component

  export default {
    components: {
      FiltersForm
    },
    data() {
      return {
        search: '',
        selectedLabels: [],
        country: {},
        status: {},
        dealSubmission: {},
        selectedAccountTypes: [],
        accountTypes: [{
          key: 'key_threads',
          name: 'Key account'
        }, {
          key: 'non_key_threads',
          name: 'Non-key account'
        }, {
          key: 'my_account',
          name: 'Show my accounts only'
        }],
        colors
      };
    },
    computed: {
      labels() {
        return this.$store.getters['labels/items'];
      },
      countries() {
        return this.$store.getters['config/countries'];
      },
      userCountries() {
        return this.$store.getters['users/countries'];
      },
      statuses() {
        return this.$store.getters['businesses/statuses'];
      },
      hasFilters() {
        const { search, selectedLabels, country, status, dealSubmission, selectedAccountTypes } = this;

        return search !== ''
          || selectedLabels.length > 0
          || isStr(country.code)
          || isNum(status.id)
          || isStr(dealSubmission.code)
          || selectedAccountTypes.length > 0;
      }
    },
    created() {
      const query = {
        per_page: -1
      };

      this.$store.dispatch('config/getCountries');
      this.$store.dispatch('labels/getItems', query);
      this.$store.dispatch('businesses/getStatuses');
    },
    methods: {
      onFilter() {
        const { search, selectedLabels, country, status, dealSubmission, selectedAccountTypes } = this;
        const formattedSearch = stringEscape(search);

        this.$emit('filter', {
          search: formattedSearch,
          labels: selectedLabels.map(({ id }) => id),
          country,
          status,
          dealSubmission,
          accountTypes: selectedAccountTypes.map(({ key }) => key)
        });
      },
      onClearFilters() {
        this.search = '';
        this.selectedLabels = [];
        this.country = {};
        this.status = {};
        this.dealSubmission = {};
        this.selectedAccountTypes = [];

        this.$emit('clearFilters');
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      }
    }
  };
</script>

<style lang="stylus">
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="filter-forms"] {
    &[data-component="businesses"] {
      h1 {
        display: flex;
        align-items: center;
        margin: 0 0 32px 0;
        min-height: 48px;
      }

      .v-select__selection {
        color: $colors.shades.white;
        background-color: $colors.primary;
        border-radius: 4px;
        padding: 5px;
      }
    }
  }
</style>
